/*
    Copyright (C) 2014 Carl Hetherington <cth@carlh.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/* THIS FILE WAS AUTO-GENERATED BY iso6937.py */

#include <map>
#include "iso6937_tables.h"

using std::map;

map<char, wchar_t> sub::iso6937::grave;
map<char, wchar_t> sub::iso6937::acute;
map<char, wchar_t> sub::iso6937::circumflex;
map<char, wchar_t> sub::iso6937::tilde;
map<char, wchar_t> sub::iso6937::macron;
map<char, wchar_t> sub::iso6937::breve;
map<char, wchar_t> sub::iso6937::dot;
map<char, wchar_t> sub::iso6937::diaeresis;
map<char, wchar_t> sub::iso6937::ring;
map<char, wchar_t> sub::iso6937::cedilla;
map<char, wchar_t> sub::iso6937::double_acute;
map<char, wchar_t> sub::iso6937::ogonek;
map<char, wchar_t> sub::iso6937::caron;
map<char, wchar_t> sub::iso6937::main;
map<char, map<char, wchar_t> *> sub::iso6937::diacriticals;

void
sub::make_iso6937_tables ()
{
	using namespace sub::iso6937;

	grave['A'] = 0x00C0;
	grave['E'] = 0x00C8;
	grave['I'] = 0x00CC;
	grave['O'] = 0x00D2;
	grave['U'] = 0x00D9;
	grave['a'] = 0x00E0;
	grave['e'] = 0x00E8;
	grave['i'] = 0x00EC;
	grave['o'] = 0x00F2;
	grave['u'] = 0x00F9;

	acute['A'] = 0x00C1;
	acute['C'] = 0x0106;
	acute['E'] = 0x00C9;
	acute['I'] = 0x00CD;
	acute['L'] = 0x0139;
	acute['N'] = 0x0143;
	acute['O'] = 0x00D3;
	acute['R'] = 0x0154;
	acute['S'] = 0x015A;
	acute['U'] = 0x00DA;
	acute['Y'] = 0x00DD;
	acute['Z'] = 0x0179;
	acute['a'] = 0x00E1;
	acute['c'] = 0x0107;
	acute['e'] = 0x00E9;
	acute['g'] = 0x01F5;
	acute['i'] = 0x00ED;
	acute['l'] = 0x013A;
	acute['n'] = 0x0144;
	acute['o'] = 0x00F3;
	acute['r'] = 0x0155;
	acute['s'] = 0x015B;
	acute['u'] = 0x00FA;
	acute['y'] = 0x00FD;
	acute['z'] = 0x017A;

	circumflex['A'] = 0x00C2;
	circumflex['C'] = 0x0108;
	circumflex['E'] = 0x00CA;
	circumflex['G'] = 0x011C;
	circumflex['H'] = 0x0124;
	circumflex['I'] = 0x00CE;
	circumflex['J'] = 0x0134;
	circumflex['O'] = 0x00D4;
	circumflex['S'] = 0x015C;
	circumflex['U'] = 0x00DB;
	circumflex['W'] = 0x0174;
	circumflex['Y'] = 0x0176;
	circumflex['a'] = 0x00E2;
	circumflex['c'] = 0x0109;
	circumflex['e'] = 0x00EA;
	circumflex['g'] = 0x011D;
	circumflex['h'] = 0x0125;
	circumflex['i'] = 0x00EE;
	circumflex['j'] = 0x0135;
	circumflex['o'] = 0x00F4;
	circumflex['s'] = 0x015D;
	circumflex['u'] = 0x00FB;
	circumflex['w'] = 0x0175;
	circumflex['y'] = 0x0177;

	tilde['A'] = 0x00C3;
	tilde['I'] = 0x0128;
	tilde['N'] = 0x00D1;
	tilde['O'] = 0x00D5;
	tilde['U'] = 0x0168;
	tilde['a'] = 0x00E3;
	tilde['i'] = 0x0129;
	tilde['n'] = 0x00F1;
	tilde['o'] = 0x00F5;
	tilde['u'] = 0x0169;

	macron['A'] = 0x0100;
	macron['E'] = 0x0112;
	macron['I'] = 0x012A;
	macron['O'] = 0x014C;
	macron['U'] = 0x016A;
	macron['a'] = 0x0101;
	macron['e'] = 0x0113;
	macron['i'] = 0x012B;
	macron['o'] = 0x014D;
	macron['u'] = 0x016B;

	breve['A'] = 0x0102;
	breve['G'] = 0x011E;
	breve['U'] = 0x016C;
	breve['a'] = 0x0103;
	breve['g'] = 0x011F;
	breve['u'] = 0x016D;

	dot['C'] = 0x010A;
	dot['E'] = 0x0116;
	dot['G'] = 0x0120;
	dot['I'] = 0x0130;
	dot['Z'] = 0x017B;
	dot['c'] = 0x010B;
	dot['e'] = 0x0117;
	dot['g'] = 0x0121;
	dot['z'] = 0x017C;

	diaeresis['A'] = 0x00C4;
	diaeresis['E'] = 0x00CB;
	diaeresis['I'] = 0x00CF;
	diaeresis['O'] = 0x00D6;
	diaeresis['U'] = 0x00DC;
	diaeresis['Y'] = 0x0178;
	diaeresis['a'] = 0x00E4;
	diaeresis['e'] = 0x00EB;
	diaeresis['i'] = 0x00EF;
	diaeresis['o'] = 0x00F6;
	diaeresis['u'] = 0x00FC;
	diaeresis['y'] = 0x00FF;

	ring['A'] = 0x00C5;
	ring['U'] = 0x016E;
	ring['a'] = 0x00E5;
	ring['u'] = 0x016F;

	cedilla['C'] = 0x00C7;
	cedilla['G'] = 0x0122;
	cedilla['K'] = 0x0136;
	cedilla['L'] = 0x013B;
	cedilla['N'] = 0x0145;
	cedilla['R'] = 0x0156;
	cedilla['S'] = 0x015E;
	cedilla['T'] = 0x0162;
	cedilla['c'] = 0x00E7;
	cedilla['k'] = 0x0137;
	cedilla['l'] = 0x013C;
	cedilla['n'] = 0x0146;
	cedilla['r'] = 0x0157;
	cedilla['s'] = 0x015F;
	cedilla['t'] = 0x0163;

	double_acute['O'] = 0x0150;
	double_acute['U'] = 0x0170;
	double_acute['o'] = 0x0151;
	double_acute['u'] = 0x0171;

	ogonek['A'] = 0x0104;
	ogonek['E'] = 0x0118;
	ogonek['I'] = 0x012E;
	ogonek['U'] = 0x0172;
	ogonek['a'] = 0x0105;
	ogonek['e'] = 0x0119;
	ogonek['u'] = 0x0173;
	ogonek['i'] = 0x012F;

	caron['C'] = 0x010C;
	caron['D'] = 0x010E;
	caron['E'] = 0x011A;
	caron['L'] = 0x013D;
	caron['N'] = 0x0147;
	caron['R'] = 0x0158;
	caron['S'] = 0x0160;
	caron['T'] = 0x0164;
	caron['Z'] = 0x017D;
	caron['c'] = 0x010D;
	caron['d'] = 0x010F;
	caron['e'] = 0x011B;
	caron['l'] = 0x013E;
	caron['n'] = 0x0148;
	caron['r'] = 0x0159;
	caron['s'] = 0x0161;
	caron['t'] = 0x0165;
	caron['z'] = 0x017E;

	main[10] = 0x000A;
	main[' '] = 0x0020;
	main['!'] = 0x0021;
	main['"'] = 0x0022;
	main['#'] = 0x0023;
	main['$'] = 0x0024;
	main['%'] = 0x0025;
	main['&'] = 0x0026;
	main['\''] = 0x0027;
	main['('] = 0x0028;
	main[')'] = 0x0029;
	main['*'] = 0x002a;
	main['+'] = 0x002b;
	main[','] = 0x002c;
	main['-'] = 0x002d;
	main['.'] = 0x002e;
	main['/'] = 0x002f;
	main['0'] = 0x0030;
	main['1'] = 0x0031;
	main['2'] = 0x0032;
	main['3'] = 0x0033;
	main['4'] = 0x0034;
	main['5'] = 0x0035;
	main['6'] = 0x0036;
	main['7'] = 0x0037;
	main['8'] = 0x0038;
	main['9'] = 0x0039;
	main[':'] = 0x003a;
	main[';'] = 0x003b;
	main['<'] = 0x003c;
	main['='] = 0x003d;
	main['>'] = 0x003e;
	main['?'] = 0x003f;
	main['@'] = 0x0040;
	main['A'] = 0x0041;
	main['B'] = 0x0042;
	main['C'] = 0x0043;
	main['D'] = 0x0044;
	main['E'] = 0x0045;
	main['F'] = 0x0046;
	main['G'] = 0x0047;
	main['H'] = 0x0048;
	main['I'] = 0x0049;
	main['J'] = 0x004a;
	main['K'] = 0x004b;
	main['L'] = 0x004c;
	main['M'] = 0x004d;
	main['N'] = 0x004e;
	main['O'] = 0x004f;
	main['P'] = 0x0050;
	main['Q'] = 0x0051;
	main['R'] = 0x0052;
	main['S'] = 0x0053;
	main['T'] = 0x0054;
	main['U'] = 0x0055;
	main['V'] = 0x0056;
	main['W'] = 0x0057;
	main['X'] = 0x0058;
	main['Y'] = 0x0059;
	main['Z'] = 0x005a;
	main['['] = 0x005b;
	main['\\'] = 0x005c;
	main[']'] = 0x005d;
	main['^'] = 0x005e;
	main['_'] = 0x005f;
	main['`'] = 0x0060;
	main['a'] = 0x0061;
	main['b'] = 0x0062;
	main['c'] = 0x0063;
	main['d'] = 0x0064;
	main['e'] = 0x0065;
	main['f'] = 0x0066;
	main['g'] = 0x0067;
	main['h'] = 0x0068;
	main['i'] = 0x0069;
	main['j'] = 0x006a;
	main['k'] = 0x006b;
	main['l'] = 0x006c;
	main['m'] = 0x006d;
	main['n'] = 0x006e;
	main['o'] = 0x006f;
	main['p'] = 0x0070;
	main['q'] = 0x0071;
	main['r'] = 0x0072;
	main['s'] = 0x0073;
	main['t'] = 0x0074;
	main['u'] = 0x0075;
	main['v'] = 0x0076;
	main['w'] = 0x0077;
	main['x'] = 0x0078;
	main['y'] = 0x0079;
	main['z'] = 0x007a;
	main['{'] = 0x007b;
	main['|'] = 0x007c;
	main['}'] = 0x007d;
	main['~'] = 0x007e;
	main[161] = 0x00A1;
	main[162] = 0x00A2;
	main[163] = 0x00A3;
	main[164] = 0x0024;
	main[165] = 0x00A5;
	main[167] = 0x00A7;
	main[168] = 0x00A4;
	main[169] = 0x2018;
	main[170] = 0x201C;
	main[171] = 0x00AB;
	main[172] = 0x2190;
	main[173] = 0x2191;
	main[174] = 0x2192;
	main[175] = 0x2193;
	main[176] = 0x00B0;
	main[177] = 0x00B1;
	main[178] = 0x00B2;
	main[179] = 0x00B3;
	main[180] = 0x00D7;
	main[181] = 0x00B5;
	main[182] = 0x00B6;
	main[183] = 0x00B7;
	main[184] = 0x00F7;
	main[185] = 0x2019;
	main[186] = 0x201D;
	main[187] = 0x00BB;
	main[188] = 0x00BC;
	main[189] = 0x00BD;
	main[190] = 0x00BE;
	main[191] = 0x00BF;
	main[193] = 0x0300;
	main[194] = 0x0301;
	main[195] = 0x0302;
	main[196] = 0x0303;
	main[197] = 0x0304;
	main[198] = 0x0306;
	main[199] = 0x0307;
	main[200] = 0x0308;
	main[202] = 0x030A;
	main[203] = 0x0327;
	main[205] = 0x030B;
	main[206] = 0x032B;
	main[207] = 0x030C;
	main[208] = 0x2015;
	main[209] = 0x00B9;
	main[210] = 0x00AE;
	main[211] = 0x00A9;
	main[212] = 0x2122;
	main[213] = 0x266A;
	main[214] = 0x00AC;
	main[215] = 0x00A6;
	main[220] = 0x215B;
	main[221] = 0x215C;
	main[222] = 0x215D;
	main[223] = 0x215E;
	main[224] = 0x2126;
	main[225] = 0x00C6;
	main[226] = 0x0110;
	main[227] = 0x00AA;
	main[228] = 0x0126;
	main[230] = 0x0132;
	main[231] = 0x013F;
	main[232] = 0x0141;
	main[233] = 0x00D8;
	main[234] = 0x0152;
	main[235] = 0x00BA;
	main[236] = 0x00DE;
	main[237] = 0x0166;
	main[238] = 0x014A;
	main[239] = 0x0149;
	main[240] = 0x0138;
	main[241] = 0x00E6;
	main[242] = 0x0111;
	main[243] = 0x00F0;
	main[244] = 0x0127;
	main[245] = 0x0131;
	main[246] = 0x0133;
	main[247] = 0x0140;
	main[248] = 0x0142;
	main[249] = 0x00F8;
	main[250] = 0x0153;
	main[251] = 0x00DF;
	main[252] = 0x00FE;
	main[253] = 0x0167;
	main[254] = 0x014B;
	main[255] = 0x00AD;

	diacriticals[0xc1] = &grave;
	diacriticals[0xc2] = &acute;
	diacriticals[0xc3] = &circumflex;
	diacriticals[0xc4] = &tilde;
	diacriticals[0xc5] = &macron;
	diacriticals[0xc6] = &breve;
	diacriticals[0xc7] = &dot;
	diacriticals[0xc8] = &diaeresis;
	diacriticals[0xca] = &ring;
	diacriticals[0xcb] = &cedilla;
	diacriticals[0xcd] = &double_acute;
	diacriticals[0xce] = &ogonek;
	diacriticals[0xcf] = &caron;
}
